# Models Builder

The Models builder is a tool that can generate a complete set of strongly-typed published content models for Umbraco. Models are available in both controllers and views.

* [Introduction](/umbraco-cms/13.latest/reference/templating/modelsbuilder/introduction.md)
* [Configuration](/umbraco-cms/13.latest/reference/templating/modelsbuilder/configuration.md)
* [Builder Modes](/umbraco-cms/13.latest/reference/templating/modelsbuilder/builder-modes.md)
* [Understand and Extend Models](/umbraco-cms/13.latest/reference/templating/modelsbuilder/understand-and-extend.md)
* [Using Interfaces](/umbraco-cms/13.latest/reference/templating/modelsbuilder/using-interfaces.md)
* [Tips and Tricks](/umbraco-cms/13.latest/reference/templating/modelsbuilder/coolthingswithmodels.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.umbraco.com/umbraco-cms/13.latest/reference/templating/modelsbuilder.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
